public class Frame { 
    Float[]   vars;
    Frame[]   display; 
    Procedure proc;
    int       pc;

    Frame(Procedure proc, Frame parent) { 
        this.proc = proc;
        vars = new Float[proc.vars.length];
        for (int i = 0; i < vars.length; i++) { 
            vars[i] = new Float();
        }
        int level = proc.level;
        display = new Frame[level+1];
        if (level > 0) { 
            System.arraycopy(parent.display, 0, display, 0, level);
        }
        display[level] = this;
        pc = 0;
    }
}
