import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class RenameProcedure extends TextBox implements CommandListener 
{
    PCalc     calc;
    List      parent;
    Procedure proc;
    int       index;

    RenameProcedure(PCalc calc, List parent, Procedure proc, int index) { 
        super("Rename procedure", proc.subprocs[index].name, 16, TextField.ANY);
        this.calc = calc;
        this.parent = parent;
        this.proc = proc;
        this.index = index;
       
        setCommandListener(this);
        addCommand(PCalc.OK_CMD);       
        addCommand(PCalc.CANCEL_CMD);       
        Display.getDisplay(calc).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c == PCalc.OK_CMD) { 
            String name = getString();
            if (!proc.subprocs[index].name.equals(name)) { 
                if (name.length() == 0) { 
                    calc.showError("Name should not be empty", this);
                    return;
                } else if (proc.findSubproc(name) >= 0) {
                    calc.showError("Procedure already exists", this);
                    return;
                }
                proc.subprocs[index].name = name;
                parent.set(index, name, null);
            }
        }
        Display.getDisplay(calc).setCurrent(parent);            
    }
}



