import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class ShowResults extends Form implements CommandListener
{
    PCalc            calc;
    Launcher         parent;
    VirtualMachine   vm;
        
    ShowResults(PCalc calc, Launcher parent, VirtualMachine vm, int elapsedTime) {
        super("Result");
        this.calc = calc;
        this.parent = parent;
        this.vm = vm;
        StringBuffer result = new StringBuffer();
        String separator = "";
        for (int i = vm.oSp; --i >= 0;) {             
            result.append(separator);
            separator = ", ";
            result.append(VirtualMachine.printNumber(vm.opdStack[i]));
        }
        append(new StringItem("Result", result.toString()));
        append(new StringItem("Execution time", elapsedTime + " millisconds"));
        setCommandListener(this);
        addCommand(PCalc.OK_CMD);
        addCommand(PCalc.RESTART_CMD);
        addCommand(PCalc.VARIABLES_CMD);
        Display.getDisplay(calc).setCurrent(this);
    }

    
    public void commandAction(Command c, Displayable d) 
    {
        if (c == PCalc.OK_CMD) { 
            Display.getDisplay(calc).setCurrent(parent.parent);
        } else if (c == PCalc.RESTART_CMD) {
            Display.getDisplay(calc).setCurrent(parent);
        } else if (c == PCalc.VARIABLES_CMD) {
            new InspectVariables(calc, this, vm.currFrame);
        }
    }
}
           


